--- /dev/null	Mon Nov 18 13:20:41 2019
+++ new/usr/src/tools/smatch/src/validation/optim/lsr-and1.c	Mon Nov 18 13:20:41 2019
@@ -0,0 +1,18 @@
+// If (t >> S) is simplified into (x >> S)
+// then the whole expression will be 0.
+// The test is only interesting if the sub-expression
+// (x & M) is referenced more than once
+// (because otherwise other simplifications apply).
+unsigned lsr_and1(unsigned x)
+{
+	unsigned t = (x & 0xfffff000);
+	return ((t >> 12) ^ (x >> 12)) & t;
+}
+
+/*
+ * check-name: lsr-and1
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-contains: ret\\..*\\$0$
+ */
--- /dev/null	Mon Nov 18 13:20:42 2019
+++ new/usr/src/tools/smatch/src/validation/optim/lsr-asr.c	Mon Nov 18 13:20:42 2019
@@ -0,0 +1,42 @@
+int lsrasr0(unsigned int x)
+{
+	return ((int) (x >> 15)) >> 15;
+}
+
+int lsrasr1(unsigned int x)
+{
+	return ((int) (x >> 16)) >> 15;
+}
+
+int lsrasr2(unsigned int x)
+{
+	return ((int) (x >> 16)) >> 16;
+}
+
+/*
+ * check-name: lsr-asr
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-start
+lsrasr0:
+.L0:
+	<entry-point>
+	lsr.32      %r3 <- %arg1, $30
+	ret.32      %r3
+
+
+lsrasr1:
+.L2:
+	<entry-point>
+	lsr.32      %r7 <- %arg1, $31
+	ret.32      %r7
+
+
+lsrasr2:
+.L4:
+	<entry-point>
+	ret.32      $0
+
+
+ * check-output-end
+ */
--- /dev/null	Mon Nov 18 13:20:42 2019
+++ new/usr/src/tools/smatch/src/validation/optim/lsr-shl0.c	Mon Nov 18 13:20:42 2019
@@ -0,0 +1,14 @@
+unsigned mask(unsigned x)
+{
+	return (x << 15) >> 15;
+}
+
+/*
+ * check-name: lsr-shl0
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-contains: and\\..*0x1ffff
+ * check-output-excludes: lsr\\.
+ * check-output-excludes: shl\\.
+ */
--- /dev/null	Mon Nov 18 13:20:42 2019
+++ new/usr/src/tools/smatch/src/validation/optim/mask-lsr.c	Mon Nov 18 13:20:42 2019
@@ -0,0 +1,14 @@
+// ((x & M) | y) >> S to (y >> S) when (M >> S) == 0
+
+unsigned int foo(unsigned int x, unsigned int y)
+{
+	return ((x & 0xff) | y) >> 8;
+}
+
+/*
+ * check-name: mask-lsr
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-excludes: %arg1
+ */
--- /dev/null	Mon Nov 18 13:20:42 2019
+++ new/usr/src/tools/smatch/src/validation/optim/mask-out.c	Mon Nov 18 13:20:42 2019
@@ -0,0 +1,12 @@
+unsigned mask(unsigned a, unsigned b)
+{
+	return ((a & 0xffff0000) | b) & 0x0000ffff;
+}
+
+/*
+ * check-name: mask-out
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-excludes: %arg1
+ */
--- /dev/null	Mon Nov 18 13:20:42 2019
+++ new/usr/src/tools/smatch/src/validation/optim/mask1-setne0.c	Mon Nov 18 13:20:42 2019
@@ -0,0 +1,28 @@
+struct s {
+	unsigned i:1;
+};
+
+int foo(struct s x)
+{
+	unsigned int i = x.i;
+
+	if (i == 0)
+		return 1;
+	else if (i == 1)
+		return 1;
+	return 0;
+}
+
+/*
+ * check-name: mask1-setne0
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-start
+foo:
+.L0:
+	<entry-point>
+	ret.32      $1
+
+
+ * check-output-end
+ */
--- /dev/null	Mon Nov 18 13:20:42 2019
+++ new/usr/src/tools/smatch/src/validation/optim/missing-select.c	Mon Nov 18 13:20:42 2019
@@ -0,0 +1,23 @@
+static int foo(int **g)
+{
+	int i = 1;
+	int *a[2];
+	int **p;
+
+	a[1] = &i;
+	if (g)
+		p = g;
+	else
+		p = &a[0];
+	if (!g)
+		**p = 0;
+	return i;
+}
+
+/*
+ * check-name: missing-select
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-contains: select\\.
+ */
--- old/usr/src/tools/smatch/src/validation/optim/muldiv-minus-one.c	Mon Nov 18 13:20:43 2019
+++ new/usr/src/tools/smatch/src/validation/optim/muldiv-minus-one.c	Mon Nov 18 13:20:43 2019
@@ -14,5 +14,5 @@
  * check-output-excludes: divs\\.
  * check-output-contains: neg\\.
  * check-output-contains: divu\\.
- * check-output-pattern-3-times: neg\\.
+ * check-output-pattern(3): neg\\.
  */
--- /dev/null	Mon Nov 18 13:20:43 2019
+++ new/usr/src/tools/smatch/src/validation/optim/null-phi.c	Mon Nov 18 13:20:43 2019
@@ -0,0 +1,9 @@
+static int foo(void)
+{
+	if (0)
+		return 0;
+}
+
+/*
+ * check-name: null-phi
+ */
--- /dev/null	Mon Nov 18 13:20:43 2019
+++ new/usr/src/tools/smatch/src/validation/optim/or-and-constant1.c	Mon Nov 18 13:20:43 2019
@@ -0,0 +1,29 @@
+unsigned int and_or_equ(unsigned int a)
+{
+	return (a | 3) & 3;
+}
+
+int and_or_eqs(int a)
+{
+	return (a | 3) & 3;
+}
+
+unsigned int or_and_equ(unsigned int a)
+{
+	return (a & 3) | 3;
+}
+
+int or_and_eqs(int a)
+{
+	return (a & 3) | 3;
+}
+
+/*
+ * check-name: or-and-constant1
+ * check-command: test-linearize -Wno-decl $file
+ * check-known-to-fail
+ *
+ * check-output-ignore
+ * check-output-pattern(4): ret\\..*\\$3
+ * check-output-excludes: or\\.
+ */
--- /dev/null	Mon Nov 18 13:20:43 2019
+++ new/usr/src/tools/smatch/src/validation/optim/phi-ret.c	Mon Nov 18 13:20:43 2019
@@ -0,0 +1,21 @@
+int foo(int p, int q, int v)
+{
+	if (q) {
+		if (p) {
+			v = p;
+			p = 0;
+		}
+	} else
+		p = 0;
+	if (p)
+		return v + 1;
+	return q;
+}
+
+/*
+ * check-name: phi-ret
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-excludes: phi\\.
+ */
--- /dev/null	Mon Nov 18 13:20:43 2019
+++ new/usr/src/tools/smatch/src/validation/optim/restrict.c	Mon Nov 18 13:20:43 2019
@@ -0,0 +1,73 @@
+extern int g, h;
+
+void f00u(int *s)
+{
+	g = *s;
+	h = *s;
+}
+
+void f00r(int *restrict s)
+{
+	g = *s;
+	h = *s;
+}
+
+
+void f01u(int *a, int *b, int *s)
+{
+	*a = *s;
+	*b = *s;
+}
+
+void f01r(int *restrict a, int *restrict b, int *restrict s)
+{
+	*a = *s;
+	*b = *s;
+}
+
+/*
+ * check-name: optim/restrict
+ * check-command: test-linearize -Wno-decl $file
+ * check-known-to-fail
+ *
+ * check-output-start
+f00u:
+.L0:
+	<entry-point>
+	load.32     %r2 <- 0[%arg1]
+	store.32    %r2 -> 0[g]
+	load.32     %r4 <- 0[%arg1]
+	store.32    %r4 -> 0[h]
+	ret
+
+
+f00r:
+.L2:
+	<entry-point>
+	load.32     %r6 <- 0[%arg1]
+	store.32    %r6 -> 0[g]
+	store.32    %r6 -> 0[h]
+	ret
+
+
+f01u:
+.L4:
+	<entry-point>
+	load.32     %r10 <- 0[%arg3]
+	store.32    %r10 -> 0[%arg1]
+	load.32     %r13 <- 0[%arg3]
+	store.32    %r13 -> 0[%arg2]
+	ret
+
+
+f01r:
+.L6:
+	<entry-point>
+	load.32     %r16 <- 0[%arg3]
+	store.32    %r16 -> 0[%arg1]
+	store.32    %r16 -> 0[%arg2]
+	ret
+
+
+ * check-output-end
+ */
--- /dev/null	Mon Nov 18 13:20:43 2019
+++ new/usr/src/tools/smatch/src/validation/optim/select-zero.c	Mon Nov 18 13:20:43 2019
@@ -0,0 +1,16 @@
+static int sel0(int a)
+{
+	if (a)
+		return 0;
+	else
+		return a;
+}
+
+/*
+ * check-name: select-zero
+ * check-command: test-linearize $file
+ *
+ * check-output-ignore
+ * check-output-contains: ret.32 *\\$0
+ * check-output-excludes: select\\.
+ */
--- /dev/null	Mon Nov 18 13:20:44 2019
+++ new/usr/src/tools/smatch/src/validation/optim/setcc-mask.c	Mon Nov 18 13:20:44 2019
@@ -0,0 +1,18 @@
+int foo (int a)
+{
+	return ((a == 0) & 1) == (a == 0);
+}
+
+/*
+ * check-name: setcc-mask
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-start
+foo:
+.L0:
+	<entry-point>
+	ret.32      $1
+
+
+ * check-output-end
+ */
--- /dev/null	Mon Nov 18 13:20:44 2019
+++ new/usr/src/tools/smatch/src/validation/optim/setne0-sext.c	Mon Nov 18 13:20:44 2019
@@ -0,0 +1,9 @@
+long foo(int a) { return a != 0; }
+
+/*
+ * check-name: setne0-sext
+ * check-command: test-linearize -m64 -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-excludes: sext\\.
+ */
--- /dev/null	Mon Nov 18 13:20:44 2019
+++ new/usr/src/tools/smatch/src/validation/optim/setne0-trunc.c	Mon Nov 18 13:20:44 2019
@@ -0,0 +1,9 @@
+char foo(int a) { return a != 0; }
+
+/*
+ * check-name: setne0-trunc
+ * check-command: test-linearize -m64 -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-excludes: trunc\\.
+ */
--- /dev/null	Mon Nov 18 13:20:44 2019
+++ new/usr/src/tools/smatch/src/validation/optim/setne0-zext.c	Mon Nov 18 13:20:44 2019
@@ -0,0 +1,9 @@
+unsigned long foo(int a) { return (unsigned int) (a != 0); }
+
+/*
+ * check-name: setne0-zext
+ * check-command: test-linearize -m64 -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-excludes: zext\\.
+ */
--- /dev/null	Mon Nov 18 13:20:44 2019
+++ new/usr/src/tools/smatch/src/validation/optim/sext-sext.c	Mon Nov 18 13:20:44 2019
@@ -0,0 +1,12 @@
+int foo(signed char offset)
+{
+	return (int)(short) offset;
+}
+
+/*
+ * check-name: sext-sext
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-pattern(1): sext\\.
+ */
--- /dev/null	Mon Nov 18 13:20:44 2019
+++ new/usr/src/tools/smatch/src/validation/optim/sext.c	Mon Nov 18 13:20:44 2019
@@ -0,0 +1,15 @@
+int sext(int x)
+{
+	return (x << 5) >> 5;
+}
+
+/*
+ * check-name: sext
+ * check-command: test-linearize -Wno-decl $file
+ * check-known-to-fail
+ *
+ * check-output-ignore
+ * check-output-contains: sext\\.$27
+ * check-output-excludes: asr\\.
+ * check-output-excludes: shl\\.
+ */
--- /dev/null	Mon Nov 18 13:20:44 2019
+++ new/usr/src/tools/smatch/src/validation/optim/sh-or-and0.c	Mon Nov 18 13:20:44 2019
@@ -0,0 +1,20 @@
+unsigned lsr_or_and0(unsigned x, unsigned b)
+{
+	return (((x & 0x00000fff) | b) >> 12);
+}
+
+unsigned shl_or_and0(unsigned x, unsigned b)
+{
+	return (((x & 0xfff00000) | b) << 12);
+}
+
+/*
+ * check-name: sh-or-and0
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-pattern(1): lsr\\.
+ * check-output-pattern(1): shl\\.
+ * check-output-excludes: or\\.
+ * check-output-excludes: and\\.
+ */
--- /dev/null	Mon Nov 18 13:20:45 2019
+++ new/usr/src/tools/smatch/src/validation/optim/sh-or-and1.c	Mon Nov 18 13:20:45 2019
@@ -0,0 +1,20 @@
+unsigned lsr_or_and1(unsigned x, unsigned b)
+{
+	return (((x & 0xfffff000) | b) >> 12);
+}
+
+unsigned shl_or_and1(unsigned x, unsigned b)
+{
+	return (((x & 0x000fffff) | b) << 12);
+}
+
+/*
+ * check-name: sh-or-and1
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-pattern(1): lsr\\.
+ * check-output-pattern(1): shl\\.
+ * check-output-pattern(2): or\\.
+ * check-output-excludes: and\\.
+ */
--- /dev/null	Mon Nov 18 13:20:45 2019
+++ new/usr/src/tools/smatch/src/validation/optim/sh-or-and2.c	Mon Nov 18 13:20:45 2019
@@ -0,0 +1,21 @@
+unsigned lsr_or_and2(unsigned x, unsigned b)
+{
+	return (((x & 0xf0ffffff) | b) >> 12);
+}
+
+unsigned shl_or_and2(unsigned x, unsigned b)
+{
+	return (((x & 0xffffff0f) | b) << 12);
+}
+
+/*
+ * check-name: sh-or-and2
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-pattern(1): lsr\\.
+ * check-output-pattern(1): shl\\.
+ * check-output-pattern(2): or\\.
+ * check-output-pattern(1): and\\..*\\$0xf0fff000
+ * check-output-pattern(1): and\\..*\\$0xfff0f
+ */
--- /dev/null	Mon Nov 18 13:20:45 2019
+++ new/usr/src/tools/smatch/src/validation/optim/shift-big.c	Mon Nov 18 13:20:45 2019
@@ -0,0 +1,82 @@
+typedef unsigned int u32;
+typedef          int s32;
+
+s32 asr31(s32 a) { return a >> 31; }
+s32 asr32(s32 a) { return a >> 32; }
+s32 asr33(s32 a) { return a >> 33; }
+
+u32 lsr31(u32 a) { return a >> 31; }
+u32 lsr32(u32 a) { return a >> 32; }
+u32 lsr33(u32 a) { return a >> 33; }
+
+u32 shl31(u32 a) { return a << 31; }
+u32 shl32(u32 a) { return a << 32; }
+u32 shl33(u32 a) { return a << 33; }
+
+/*
+ * check-name: optim/shift-big.c
+ * check-command: test-linearize -Wno-decl -m64 $file
+ *
+ * check-error-ignore
+ * check-output-start
+asr31:
+.L0:
+	<entry-point>
+	asr.32      %r2 <- %arg1, $31
+	ret.32      %r2
+
+
+asr32:
+.L2:
+	<entry-point>
+	asr.32      %r5 <- %arg1, $32
+	ret.32      %r5
+
+
+asr33:
+.L4:
+	<entry-point>
+	asr.32      %r8 <- %arg1, $33
+	ret.32      %r8
+
+
+lsr31:
+.L6:
+	<entry-point>
+	lsr.32      %r11 <- %arg1, $31
+	ret.32      %r11
+
+
+lsr32:
+.L8:
+	<entry-point>
+	ret.32      $0
+
+
+lsr33:
+.L10:
+	<entry-point>
+	ret.32      $0
+
+
+shl31:
+.L12:
+	<entry-point>
+	shl.32      %r20 <- %arg1, $31
+	ret.32      %r20
+
+
+shl32:
+.L14:
+	<entry-point>
+	ret.32      $0
+
+
+shl33:
+.L16:
+	<entry-point>
+	ret.32      $0
+
+
+ * check-output-end
+ */
--- /dev/null	Mon Nov 18 13:20:45 2019
+++ new/usr/src/tools/smatch/src/validation/optim/shift-shift.c	Mon Nov 18 13:20:45 2019
@@ -0,0 +1,149 @@
+unsigned int shl0(unsigned int x)
+{
+	return x << 15 << 15;
+}
+
+unsigned int shl1(unsigned int x)
+{
+	return x << 16 << 15;
+}
+
+unsigned int shl2(unsigned int x)
+{
+	return x << 16 << 16;
+}
+
+unsigned int shl3(unsigned int x)
+{
+	return x << 12 << 10 << 10;
+}
+
+
+unsigned int lsr0(unsigned int x)
+{
+	return x >> 15 >> 15;
+}
+
+unsigned int lsr1(unsigned int x)
+{
+	return x >> 16 >> 15;
+}
+
+unsigned int lsr2(unsigned int x)
+{
+	return x >> 16 >> 16;
+}
+
+unsigned int lsr3(unsigned int x)
+{
+	return x >> 12 >> 10 >> 10;
+}
+
+
+int asr0(int x)
+{
+	return x >> 15 >> 15;
+}
+
+int asr1(int x)
+{
+	return x >> 16 >> 15;
+}
+
+int asr2(int x)
+{
+	return x >> 16 >> 16;
+}
+
+int asr3(int x)
+{
+	return x >> 12 >> 10 >> 10;
+}
+
+/*
+ * check-name: shift-shift
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-start
+shl0:
+.L0:
+	<entry-point>
+	shl.32      %r3 <- %arg1, $30
+	ret.32      %r3
+
+
+shl1:
+.L2:
+	<entry-point>
+	shl.32      %r7 <- %arg1, $31
+	ret.32      %r7
+
+
+shl2:
+.L4:
+	<entry-point>
+	ret.32      $0
+
+
+shl3:
+.L6:
+	<entry-point>
+	ret.32      $0
+
+
+lsr0:
+.L8:
+	<entry-point>
+	lsr.32      %r20 <- %arg1, $30
+	ret.32      %r20
+
+
+lsr1:
+.L10:
+	<entry-point>
+	lsr.32      %r24 <- %arg1, $31
+	ret.32      %r24
+
+
+lsr2:
+.L12:
+	<entry-point>
+	ret.32      $0
+
+
+lsr3:
+.L14:
+	<entry-point>
+	ret.32      $0
+
+
+asr0:
+.L16:
+	<entry-point>
+	asr.32      %r37 <- %arg1, $30
+	ret.32      %r37
+
+
+asr1:
+.L18:
+	<entry-point>
+	asr.32      %r41 <- %arg1, $31
+	ret.32      %r41
+
+
+asr2:
+.L20:
+	<entry-point>
+	asr.32      %r45 <- %arg1, $31
+	ret.32      %r45
+
+
+asr3:
+.L22:
+	<entry-point>
+	asr.32      %r50 <- %arg1, $31
+	ret.32      %r50
+
+
+ * check-output-end
+ */
--- /dev/null	Mon Nov 18 13:20:45 2019
+++ new/usr/src/tools/smatch/src/validation/optim/shift-zext.c	Mon Nov 18 13:20:45 2019
@@ -0,0 +1,12 @@
+unsigned int foo(unsigned int x)
+{
+	return (x << 20) >> 20;
+}
+
+/*
+ * check-name: shift-zext
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-contains: and\\..*%arg1, \\$0xfff
+ */
--- /dev/null	Mon Nov 18 13:20:45 2019
+++ new/usr/src/tools/smatch/src/validation/optim/shl-and0.c	Mon Nov 18 13:20:45 2019
@@ -0,0 +1,13 @@
+unsigned shl_and0(unsigned x)
+{
+	unsigned t = (x & 0xfff00000);
+	return (t << 12) & t;
+}
+
+/*
+ * check-name: shl-and0
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-contains: ret\\..*\\$0$
+ */
--- /dev/null	Mon Nov 18 13:20:45 2019
+++ new/usr/src/tools/smatch/src/validation/optim/shl-and1.c	Mon Nov 18 13:20:45 2019
@@ -0,0 +1,18 @@
+// If (t << S) is simplified into (x << S)
+// then the whole expression will be 0.
+// The test is only interesting if the sub-expression
+// (x & M) is referenced more than once
+// (because otherwise other simplifications apply).
+unsigned shl_and1(unsigned x)
+{
+	unsigned t = (x & 0x000fffff);
+	return ((t << 12) ^ (x << 12)) & t;
+}
+
+/*
+ * check-name: shl-and1
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-contains: ret\\..*\\$0$
+ */
--- /dev/null	Mon Nov 18 13:20:46 2019
+++ new/usr/src/tools/smatch/src/validation/optim/shl-lsr0.c	Mon Nov 18 13:20:46 2019
@@ -0,0 +1,14 @@
+unsigned mask(unsigned x)
+{
+	return (x >> 15) << 15;
+}
+
+/*
+ * check-name: shl-lsr0
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-contains: and\\..*0xffff8000
+ * check-output-excludes: lsr\\.
+ * check-output-excludes: shl\\.
+ */
--- /dev/null	Mon Nov 18 13:20:46 2019
+++ new/usr/src/tools/smatch/src/validation/optim/store-dominated.c	Mon Nov 18 13:20:46 2019
@@ -0,0 +1,15 @@
+static int a[];
+
+static void foo(void)
+{
+	int *c = &a[1];
+	*c = *c = 0;
+}
+
+/*
+ * check-name: store-dominated
+ * check-command: test-linearize $file
+ *
+ * check-output-ignore
+ * check-output-excludes: add\\.
+ */
--- /dev/null	Mon Nov 18 13:20:46 2019
+++ new/usr/src/tools/smatch/src/validation/optim/trivial-phis.c	Mon Nov 18 13:20:46 2019
@@ -0,0 +1,14 @@
+void foo(int a)
+{
+	while (1)
+		a ^= 0;
+}
+
+/*
+ * check-name: trivial phis
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-excludes: phi\\.
+ * check-output-excludes: phisrc\\.
+ */
--- /dev/null	Mon Nov 18 13:20:46 2019
+++ new/usr/src/tools/smatch/src/validation/optim/trunc-mask-zext.c	Mon Nov 18 13:20:46 2019
@@ -0,0 +1,13 @@
+unsigned long long foo(unsigned long long x)
+{
+	return (((unsigned int) x) & 0x7ffU);
+}
+
+/*
+ * check-name: trunc-mask-zext
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-excludes: trunc\\.
+ * check-output-excludes: zext\\.
+ */
--- /dev/null	Mon Nov 18 13:20:46 2019
+++ new/usr/src/tools/smatch/src/validation/optim/trunc-or-shl.c	Mon Nov 18 13:20:46 2019
@@ -0,0 +1,13 @@
+char foo(int a, int b)
+{
+	return (a << 8) | b;
+}
+
+/*
+ * check-name: trunc-or-shl
+ * check-command: test-linearize -Wno-decl $file
+ * check-known-to-fail
+ *
+ * check-output-ignore
+ * check-output-contains: ret\\..*%arg2
+ */
--- /dev/null	Mon Nov 18 13:20:46 2019
+++ new/usr/src/tools/smatch/src/validation/optim/trunc-seteq0.c	Mon Nov 18 13:20:46 2019
@@ -0,0 +1,18 @@
+struct S {
+	         int  :1;
+	  signed int s:2;
+	unsigned int u:3;
+};
+
+int os(int i, struct S *b) { return i || b->s; }
+int ou(int i, struct S *b) { return i || b->u; }
+
+/*
+ * check-name: trunc-seteq0
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-excludes: trunc\\.
+ * check-output-excludes: sext\\.
+ * check-output-excludes: zext\\.
+ */
--- /dev/null	Mon Nov 18 13:20:46 2019
+++ new/usr/src/tools/smatch/src/validation/optim/trunc-setne0.c	Mon Nov 18 13:20:46 2019
@@ -0,0 +1,20 @@
+struct s {
+	unsigned int u:1;
+};
+
+unsigned int foo(struct s x)
+{
+	if (x.u)
+		return 1;
+	else
+		return 0;
+}
+
+/*
+ * check-name: trunc-setne0
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-contains: and\\.
+ * check-output-excludes: trunc\\.
+ */
--- /dev/null	Mon Nov 18 13:20:46 2019
+++ new/usr/src/tools/smatch/src/validation/optim/trunc-trunc.c	Mon Nov 18 13:20:46 2019
@@ -0,0 +1,12 @@
+char foo(int a)
+{
+	return ((((short) a) + 1) - 1);
+}
+
+/*
+ * check-name: trunc-trunc
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-pattern(1): trunc\\.
+ */
--- /dev/null	Mon Nov 18 13:20:47 2019
+++ new/usr/src/tools/smatch/src/validation/optim/volatile-bitfield.c	Mon Nov 18 13:20:47 2019
@@ -0,0 +1,16 @@
+struct s {
+	int f:3;
+};
+
+void foo(volatile struct s *p)
+{
+	p->f;
+}
+
+/*
+ * check-name: volatile-bitfield
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-contains: load\\.
+ */
--- /dev/null	Mon Nov 18 13:20:47 2019
+++ new/usr/src/tools/smatch/src/validation/optim/volatile-side-effect.c	Mon Nov 18 13:20:47 2019
@@ -0,0 +1,13 @@
+void foo(int p, volatile int *ptr)
+{
+	p ? : *ptr;
+	p ? : *ptr;
+}
+
+/*
+ * check-name: volatile-side-effect
+ * check-command: test-linearize -Wno-decl $file
+ * check-output-ignore
+ *
+ * check-output-pattern(2): load
+ */
--- /dev/null	Mon Nov 18 13:20:47 2019
+++ new/usr/src/tools/smatch/src/validation/optim/volatile-store00.c	Mon Nov 18 13:20:47 2019
@@ -0,0 +1,27 @@
+void foo(volatile int *p)
+{
+	*p = 0;
+	*p = 0;
+}
+
+void bar(void)
+{
+	extern volatile int i;
+	i = 0;
+	i = 0;
+}
+
+
+void baz(void)
+{
+	volatile int i;
+	i = 0;
+	i = 0;
+}
+
+/*
+ * check-name: keep volatile stores
+ * check-command: test-linearize -Wno-decl -fdump-ir=final $file
+ * check-output-ignore
+ * check-output-pattern(6): store\\.
+ */
--- /dev/null	Mon Nov 18 13:20:47 2019
+++ new/usr/src/tools/smatch/src/validation/optim/zext-and.c	Mon Nov 18 13:20:47 2019
@@ -0,0 +1,12 @@
+unsigned int foo(unsigned char x)
+{
+	return (unsigned int)x & 0xffffU;
+}
+
+/*
+ * check-name: zext-and
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-excludes: and\\.
+ */
--- /dev/null	Mon Nov 18 13:20:47 2019
+++ new/usr/src/tools/smatch/src/validation/optim/zext-and1.c	Mon Nov 18 13:20:47 2019
@@ -0,0 +1,12 @@
+unsigned int bar(unsigned char x)
+{
+	return (unsigned int)x & 0xff01U;
+}
+
+/*
+ * check-name: zext-and1
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-contains: and\\..*\\$1
+ */
--- /dev/null	Mon Nov 18 13:20:47 2019
+++ new/usr/src/tools/smatch/src/validation/optim/zext-asr.c	Mon Nov 18 13:20:47 2019
@@ -0,0 +1,13 @@
+unsigned short foo(unsigned short a)
+{
+	return a >> 16;
+}
+
+/*
+ * check-name: zext-asr
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-contains: ret\\..*\\$0
+ * check-output-excludes: asr\\.
+ */
--- /dev/null	Mon Nov 18 13:20:47 2019
+++ new/usr/src/tools/smatch/src/validation/optim/zext-sext.c	Mon Nov 18 13:20:47 2019
@@ -0,0 +1,13 @@
+int foo(unsigned char offset)
+{
+	return (int)(short) offset;
+}
+
+/*
+ * check-name: zext-sext
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-excludes: sext\\.
+ * check-output-pattern(1): zext\\.
+ */
--- /dev/null	Mon Nov 18 13:20:47 2019
+++ new/usr/src/tools/smatch/src/validation/optim/zext-zext.c	Mon Nov 18 13:20:48 2019
@@ -0,0 +1,13 @@
+int foo(unsigned char offset)
+{
+	return (int)(unsigned short) offset;
+}
+
+/*
+ * check-name: zext-zext
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-excludes: sext\\.
+ * check-output-pattern(1): zext\\.
+ */
--- /dev/null	Mon Nov 18 13:20:48 2019
+++ new/usr/src/tools/smatch/src/validation/option-parsing-00.c	Mon Nov 18 13:20:48 2019
@@ -0,0 +1,5 @@
+
+/*
+ * check-name: option parsing 00
+ * check-command: sparse -foptimize-xyz $file
+ */
--- /dev/null	Mon Nov 18 13:20:48 2019
+++ new/usr/src/tools/smatch/src/validation/option-parsing-01.c	Mon Nov 18 13:20:48 2019
@@ -0,0 +1,5 @@
+
+/*
+ * check-name: option parsing 01
+ * check-command: sparse -fno-optimize-xyz $file
+ */
--- /dev/null	Mon Nov 18 13:20:48 2019
+++ new/usr/src/tools/smatch/src/validation/overflow.c	Mon Nov 18 13:20:48 2019
@@ -0,0 +1,19 @@
+extern int a;
+
+int a = __INT_MAX__ * 2;
+
+int foo(void)
+{
+	return __INT_MAX__ * 2;
+}
+
+/*
+ * check-name: overflow
+ * check-command: sparse -Wno-decl $file
+ *
+ * check-known-to-fail
+ * check-error-start
+bug-overflow.c:3:21: warning: integer overflow in expression
+bug-overflow.c:7:28: warning: integer overflow in expression
+ * check-error-end
+ */
--- /dev/null	Mon Nov 18 13:20:48 2019
+++ new/usr/src/tools/smatch/src/validation/preprocessor/base-file.c	Mon Nov 18 13:20:48 2019
@@ -0,0 +1,17 @@
+__FILE__
+__BASE_FILE__
+
+#include "base-file.h"
+
+/*
+ * check-name: base file
+ * check-command: sparse -E $file
+ *
+ * check-output-start
+
+"preprocessor/base-file.c"
+"preprocessor/base-file.c"
+"preprocessor/base-file.h"
+"preprocessor/base-file.c"
+ * check-output-end
+ */
--- /dev/null	Mon Nov 18 13:20:48 2019
+++ new/usr/src/tools/smatch/src/validation/preprocessor/base-file.h	Mon Nov 18 13:20:48 2019
@@ -0,0 +1,2 @@
+__FILE__
+__BASE_FILE__
--- /dev/null	Mon Nov 18 13:20:48 2019
+++ new/usr/src/tools/smatch/src/validation/preprocessor/builtin.c	Mon Nov 18 13:20:48 2019
@@ -0,0 +1,17 @@
+__CHECKER__
+F(__CHECKER__,__CHECKER__)
+S(#__CHECKER__)
+const char str[] = "__CHECKER__";
+
+/*
+ * check-name: builtin
+ * check-command: sparse -E $file
+ *
+ * check-output-start
+
+1
+F(1,1)
+S(#1)
+const char str[] = "__CHECKER__";
+ * check-output-end
+ */
--- /dev/null	Mon Nov 18 13:20:48 2019
+++ new/usr/src/tools/smatch/src/validation/preprocessor/cli-D-arg.c	Mon Nov 18 13:20:48 2019
@@ -0,0 +1,12 @@
+A
+B
+/*
+ * check-name: cli: -D MACRO
+ * check-command: sparse -E -D A -D B=abc $file
+ *
+ * check-output-start
+
+1
+abc
+ * check-output-end
+ */
--- /dev/null	Mon Nov 18 13:20:49 2019
+++ new/usr/src/tools/smatch/src/validation/preprocessor/cli-D-space.c	Mon Nov 18 13:20:49 2019
@@ -0,0 +1,10 @@
+M(0,1)
+/*
+ * check-name: cli: allow spaces in macros
+ * check-command: sparse -E '-DM(X, Y)=a' $file
+ *
+ * check-output-start
+
+a
+ * check-output-end
+ */
--- old/usr/src/tools/smatch/src/validation/preprocessor/dump-macros-empty.c	Mon Nov 18 13:20:49 2019
+++ new/usr/src/tools/smatch/src/validation/preprocessor/dump-macros-empty.c	Mon Nov 18 13:20:49 2019
@@ -3,5 +3,5 @@
  * check-command: sparse -E -dD empty-file
  *
  * check-output-ignore
-check-output-pattern-1-times: #define __CHECKER__ 1
+check-output-pattern(1): #define __CHECKER__ 1
  */
--- old/usr/src/tools/smatch/src/validation/preprocessor/dump-macros-multi.c	Mon Nov 18 13:20:49 2019
+++ new/usr/src/tools/smatch/src/validation/preprocessor/dump-macros-multi.c	Mon Nov 18 13:20:49 2019
@@ -3,5 +3,5 @@
  * check-command: sparse -E -dD empty-file $file
  *
  * check-output-ignore
-check-output-pattern-2-times: #define __CHECKER__ 1
+check-output-pattern(2): #define __CHECKER__ 1
  */
--- /dev/null	Mon Nov 18 13:20:49 2019
+++ new/usr/src/tools/smatch/src/validation/preprocessor/dump-macros-only.c	Mon Nov 18 13:20:49 2019
@@ -0,0 +1,36 @@
+
+#define ABC abc
+#undef ABC
+
+#define	DEF def
+#undef DEF
+#define DEF xyz
+
+#define NYDEF ydef
+
+#define STRING(x) #x
+#define CONCAT(x,y) x ## y
+
+#define unlocks(...) annotate(unlock_func(__VA_ARGS__))
+#define apply(x,...) x(__VA_ARGS__)
+
+int main(int argc, char *argv[])
+{
+	return 0;
+}
+/*
+ * check-name: dump-macros only -dM
+ * check-command: sparse -E -dM -DIJK=ijk -UNDEF -UNYDEF $file
+ *
+ * check-output-ignore
+check-output-pattern(1): #define __CHECKER__ 1
+check-output-contains: #define IJK ijk
+check-output-contains: #define DEF xyz
+check-output-contains: #define NYDEF ydef
+check-output-contains: #define STRING(x) #x
+check-output-contains: #define CONCAT(x,y) x ## y
+check-output-contains: #define unlocks(...) annotate(unlock_func(__VA_ARGS__))
+check-output-contains: #define apply(x,...) x(__VA_ARGS__)
+check-output-excludes: int main(int argc, char \\*argv\\[\\])
+check-output-excludes: ^\\[^#]
+ */
--- old/usr/src/tools/smatch/src/validation/preprocessor/dump-macros.c	Mon Nov 18 13:20:49 2019
+++ new/usr/src/tools/smatch/src/validation/preprocessor/dump-macros.c	Mon Nov 18 13:20:50 2019
@@ -6,13 +6,29 @@
 #define DEF xyz
 
 #define NYDEF ydef
+
+#define STRING(x) #x
+#define CONCAT(x,y) x ## y
+
+#define unlocks(...) annotate(unlock_func(__VA_ARGS__))
+#define apply(x,...) x(__VA_ARGS__)
+
+int main(int argc, char *argv[])
+{
+	return 0;
+}
 /*
  * check-name: dump-macros
  * check-command: sparse -E -dD -DIJK=ijk -UNDEF -UNYDEF $file
  *
  * check-output-ignore
-check-output-pattern-1-times: #define __CHECKER__ 1
+check-output-pattern(1): #define __CHECKER__ 1
 check-output-contains: #define IJK ijk
 check-output-contains: #define DEF xyz
 check-output-contains: #define NYDEF ydef
+check-output-contains: #define STRING(x) #x
+check-output-contains: #define CONCAT(x,y) x ## y
+check-output-contains: #define unlocks(...) annotate(unlock_func(__VA_ARGS__))
+check-output-contains: #define apply(x,...) x(__VA_ARGS__)
+check-output-contains: int main(int argc, char \\*argv\\[\\])
  */
--- /dev/null	Mon Nov 18 13:20:50 2019
+++ new/usr/src/tools/smatch/src/validation/preprocessor/dynamic.c	Mon Nov 18 13:20:50 2019
@@ -0,0 +1,37 @@
+#if defined(__LINE__)
+__LINE__
+#endif
+#if defined(__FILE__)
+__FILE__
+#endif
+#if defined(__BASE_FILE__)
+__BASE_FILE__
+#endif
+#if defined(__DATE__)
+date
+#endif
+#if defined(__TIME__)
+time
+#endif
+#if defined(__COUNTER__)
+counter
+#endif
+#if defined(__INCLUDE_LEVEL__)
+__INCLUDE_LEVEL__
+#endif
+
+/*
+ * check-name: dynamic-macros
+ * check-command: sparse -E $file
+ *
+ * check-output-start
+
+2
+"preprocessor/dynamic.c"
+"preprocessor/dynamic.c"
+date
+time
+counter
+0
+ * check-output-end
+ */
--- /dev/null	Mon Nov 18 13:20:50 2019
+++ new/usr/src/tools/smatch/src/validation/preprocessor/extra-token.c	Mon Nov 18 13:20:50 2019
@@ -0,0 +1,15 @@
+#define THIS 0
+#ifdef THIS == 1
+#endif
+
+/*
+ * check-name: preprocessor/extra-token.c
+ * check-command: sparse -E $file
+ * check-known-to-fail
+ *
+ * check-error-start
+preprocessor/extra-token.c:2:13: warning: extra tokens at end of #ifdef directive
+ * check-error-end
+ *
+ * check-output-ignore
+ */
--- /dev/null	Mon Nov 18 13:20:50 2019
+++ new/usr/src/tools/smatch/src/validation/preprocessor/has-attribute.c	Mon Nov 18 13:20:50 2019
@@ -0,0 +1,56 @@
+#ifndef __has_attribute
+__has_attribute()??? Quesako?
+#define __has_attribute(x) 0
+#else
+"has __has_attribute(), yeah!"
+#endif
+
+123 __has_attribute(nothinx) def
+
+#if __has_attribute(nothinx)
+#error "not a attribute!"
+#endif
+
+#if 1					\
+ && __has_attribute(packed)		\
+ && __has_attribute(aligned)		\
+ && __has_attribute(const)		\
+ && __has_attribute(pure)		\
+ && __has_attribute(noreturn)		\
+ && __has_attribute(designated_init)	\
+ && __has_attribute(transparent_union)	\
+
+"ok gcc"
+#endif
+
+#if 1					\
+ && __has_attribute(fastcall)		\
+
+"ok gcc ignore"
+#endif
+
+#if 1					\
+ && __has_attribute(nocast)		\
+ && __has_attribute(noderef)		\
+ && __has_attribute(safe)		\
+ && __has_attribute(force)		\
+ && __has_attribute(bitwise)		\
+ && __has_attribute(address_space)	\
+ && __has_attribute(context)		\
+
+"ok sparse specific"
+#endif
+
+/*
+ * check-name: has-attribute
+ * check-command: sparse -E $file
+ *
+ * check-output-start
+
+"has __has_attribute(), yeah!"
+123 0 def
+"ok gcc"
+"ok gcc ignore"
+"ok sparse specific"
+ * check-output-end
+ */
--- /dev/null	Mon Nov 18 13:20:50 2019
+++ new/usr/src/tools/smatch/src/validation/preprocessor/has-builtin.c	Mon Nov 18 13:20:50 2019
@@ -0,0 +1,43 @@
+#ifndef __has_builtin
+__has_builtin()??? Quesako?
+#define __has_builtin(x) 0
+#else
+"has __has_builtin(), yeah!"
+#endif
+
+#if __has_builtin(nothing)
+#error "not a builtin!"
+#endif
+
+#if __has_builtin(__builtin_offsetof)		\
+ || __has_builtin(__builtin_types_compatible_p)
+#error "builtin ops are not builtin functions!"
+#endif
+
+#if __has_builtin(__builtin_va_list)		\
+ || __has_builtin(__builtin_ms_va_list)
+#error "builtin types are not builtin functions!"
+#endif
+
+#if __has_builtin(__builtin_abs)
+abs
+#endif
+
+#if __has_builtin(__builtin_constant_p)
+constant_p
+#endif
+
+123 __has_builtin(abc) def
+
+/*
+ * check-name: has-builtin
+ * check-command: sparse -E $file
+ *
+ * check-output-start
+
+"has __has_builtin(), yeah!"
+abs
+constant_p
+123 0 def
+ * check-output-end
+ */
--- /dev/null	Mon Nov 18 13:20:50 2019
+++ new/usr/src/tools/smatch/src/validation/preprocessor/ident-pragma.c	Mon Nov 18 13:20:50 2019
@@ -0,0 +1,12 @@
+#pragma ident "foo"
+
+/*
+ * check-description: check that '#pragma ident ... " is ignored.
+ * check-name: ident-pragma
+ * check-command: sparse -E $file
+ *
+ * check-output-start
+
+
+ * check-output-end
+ */
--- /dev/null	Mon Nov 18 13:20:51 2019
+++ new/usr/src/tools/smatch/src/validation/preprocessor/ident.c	Mon Nov 18 13:20:51 2019
@@ -0,0 +1,12 @@
+#ident "foo"
+
+/*
+ * check-description: check that the non-standard "#ident ..." is ignored.
+ * check-name: ident
+ * check-command: sparse -E $file
+ *
+ * check-output-start
+
+
+ * check-output-end
+ */
